DH_MAKESHLIBS(1)

NAME
dh_makeshlibs - automatically create shlibs file and call dpkg-gensymbols

SYNOPSIS
dh_makeshlibs [debhelper options] [-mmajor] [-V[dependencies]] [-n] [-Xitem] [-- params]

DESCRIPTION
dh_makeshlibs is a debhelper program that automatically scans for shared libraries, and generates a shlibs file for the libraries it finds.

It will also ensure that ldconfig is invoked during install and removal when it finds shared libraries. Since debhelper 9.20151004, this is done via a dpkg trigger. In older versions of debhelper, dh_makeshlibs would generate a maintainer script for this purpose.

FILES

debian/package.shlibs
    Installs this file, if present, into the package as DEBIAN/shlibs. If omitted, debhelper will generate a shlibs file automatically if it detects any libraries.

    Note in compat levels 9 and earlier, this file was installed by dh_installdeb(1) rather than dh_makeshlibs.

debian/package.symbols
debian/package.symbols.arch
    These symbols files, if present, are passed to dpkg-gensymbols(1) to be processed and installed. Use the arch specific names if you need to provide different symbols files for different architectures.

OPTIONS

-mmajor, --major=major
    Instead of trying to guess the major number of the library with objdump, use the major number specified after the -m parameter. This is much less useful than it used to be, back in the bad old days when this program looked at library filenames rather than using objdump.

-V, -Vdependencies
--version-info, --version-info=dependencies
    By default, the shlibs file generated by this program does not make packages depend on any particular version of the package containing the shared library. It may be necessary for you to add some version dependency information to the shlibs file. If -V is specified with no dependency information, the current upstream version of the package is plugged into a dependency that looks like "packagename (>= packageversion)". Note that in debhelper compatibility levels before v4, the Debian part of the package version number is also included. If -V is specified with parameters, the parameters can be used to specify the exact dependency information needed (be sure to include the package name).

    Beware of using -V without any parameters; this is a conservative setting that always ensures that other packages' shared library dependencies are at least as tight as they need to be (unless your library is prone to changing ABI without updating the upstream version number), so that if the maintainer screws up then they won't break. The flip side is that packages might end up with dependencies that are too tight and so find it harder to be upgraded.

-n, --no-scripts
    Do not add the "ldconfig" trigger even if it seems like the package might need it. The option is called --no-scripts for historical reasons as dh_makeshlibs would previously generate maintainer scripts that called ldconfig.

-Xitem, --exclude=item
    Exclude files that contain item anywhere in their filename or directory from being treated as shared libraries.

--add-udeb=udeb
    Create an additional line for udebs in the shlibs file and use udeb as the package name for udebs to depend on instead of the regular library package.

-- params
    Pass params to dpkg-gensymbols(1).

EXAMPLES

dh_makeshlibs
    Assuming this is a package named libfoobar1, generates a shlibs file that looks something like:
     libfoobar 1 libfoobar1

dh_makeshlibs -V
    Assuming the current version of the package is 1.1-3, generates a shlibs file that looks something like:
     libfoobar 1 libfoobar1 (>= 1.1)

dh_makeshlibs -V 'libfoobar1 (>= 1.0)'
    Generates a shlibs file that looks something like:
      libfoobar 1 libfoobar1 (>= 1.0)

SEE ALSO
debhelper(7)

This program is a part of debhelper.

AUTHOR
Joey Hess <joeyh@debian.org>